#include <Wire.h>
#include <SPI.h>
#include <SD.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BMP085_U.h>
#include <DHT.h>
#include <QMC5883LCompass.h>

#include <RTClib.h>
RTC_DS1307 RTC;
QMC5883LCompass compass;

#define DHTPIN 2
#define DHTTYPE DHT22
DHT dht(DHTPIN, DHTTYPE);

#define BMP_SDA 4
#define BMP_SCL 5
Adafruit_BMP085_Unified bmp = Adafruit_BMP085_Unified(10085);

const int chipSelect = 10;

int pin = 8;
unsigned long runCounter = 0;
unsigned long duration;
unsigned long starttime;
unsigned long sampletime_ms = 30000;//sampe 30s ;
unsigned long lowpulseoccupancy = 0;
float ratio = 0;
float concentration = 0;
float ugm3 = 0;

void setup() {
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }


  Serial.print("Initializing SD card...");

  // see if the card is present and can be initialized:
  if (!SD.begin(chipSelect)) {
    Serial.println("Card failed, or not present");
    // don't do anything more:
    while (1);
  }
  Serial.println("card initialized.");

//  Serial.begin(9600);
  pinMode(A0,INPUT); 

//  Serial.begin(9600);
  compass.init();

  Wire.begin();
  if (!bmp.begin()) {
    Serial.println("BMP085 sensor not found");
    while (1) {}
  }
  dht.begin();
  RTC.begin();
  


  // see if the card is present and can be initialized:
  if (!SD.begin(chipSelect)) {
    Serial.println("Card failed, or not present");
    // don't do anything more:
    while (1);
  }

//  if (!SD.begin(chipSelect)) {
//    Serial.println("SD card initialization failed!");
//    return;
//  }

  //if (!RTC_DS1307.begin()) {
  //  Serial.println("RTC DS1307 initialization failed!");
  //  return;
  //}

  //if (!RTC_DS1307.isrunning()) {
  //  Serial.println("RTC DS1307 not running, setting the time...");
  //  RTC_DS1307.adjust(DateTime(F(__DATE__), F(__TIME__)));
  //}
  if (!RTC.isrunning()) {
   Serial.println("RTC is NOT running!");
   // following line sets the RTC to the date & time this sketch was compiled
   RTC.adjust(DateTime(__DATE__, __TIME__));
  }
  Serial.println("card initialized.");
}

void loop() {

  // make a string for assembling the data to log:
//  String dataString = "";

  // read three sensors and append to the string:
//  for (int analogPin = 0; analogPin < 5; analogPin++) {
//    int sensor = analogRead(analogPin);
//    dataString += String(sensor);
//    if (analogPin < 4) {
//      dataString += ",";
//    }
//  }

  File dataFile = SD.open("log2.txt", FILE_WRITE);

  //DateTime now = RTC_DS1307.now();
  DateTime now = RTC.now();
  sensors_event_t event;
  bmp.getEvent(&event);
  //mag.getEvent(&event);
  float temperature, pressure;
  bmp.getTemperature(&temperature);
  bmp.getPressure(&pressure);
  float baro = pressure/100;
  float h = dht.readHumidity();
  float t = dht.readTemperature();
  //float heading = atan2(event.magnetic.z, event.magnetic.y);

  float x = analogRead(A0)*3.6/180;

  compass.read();
  byte a = compass.getAzimuth();
  char myArray[3];
  compass.getDirection(myArray, a);

  duration = pulseIn(pin, LOW);
  lowpulseoccupancy = lowpulseoccupancy+duration;

  if ((millis()-starttime) > sampletime_ms)//if the sampel time == 30s
  {
    ratio = lowpulseoccupancy/(sampletime_ms*10.0);  // Integer percentage 0=>100
    concentration = 1.1*pow(ratio,3)-3.8*pow(ratio,2)+520*ratio+0.62; // using spec sheet curve
    ugm3 = concentration*100/13000;
    lowpulseoccupancy = 0;
    starttime = millis();
  }

  if (dataFile) {
    dataFile.print(now.year(), DEC);
    dataFile.print('/');
    dataFile.print(now.month(), DEC);
    dataFile.print('/');
    dataFile.print(now.day(), DEC);
    dataFile.print(' ');
    dataFile.print(now.hour(), DEC);
    dataFile.print(':');
    dataFile.print(now.minute(), DEC);
    dataFile.print(':');
    dataFile.print(now.second(), DEC);
    dataFile.print(',');
    dataFile.print(t);
    dataFile.print(',');
    dataFile.print(h);
    dataFile.print(',');
    dataFile.print(baro);
    dataFile.print(',');
    //dataFile.println(bmp.pressureToAltitude(1013.25, pressure));
    //dataFile.print(',');
    dataFile.print(myArray[0]);dataFile.print(myArray[1]);dataFile.print(myArray[2]);
    dataFile.print(',');
    dataFile.print(x); //dataFile.print("m/s");
    dataFile.print(',');
    dataFile.println(ugm3); //dataFile.println("pm1");
    dataFile.close();

    Serial.print(now.year(), DEC);
    Serial.print('/');
    Serial.print(now.month(), DEC);
    Serial.print('/');
    Serial.print(now.day(), DEC);
    Serial.print(' ');
    Serial.print(now.hour(), DEC);
    Serial.print(':');
    Serial.print(now.minute(), DEC);
    Serial.print(':');
    Serial.print(now.second(), DEC);
    Serial.print(',');
    Serial.print(t);
    Serial.print(',');
    Serial.print(h);
    Serial.print(',');
    //Serial.print(pressure);
    Serial.print(baro);
    Serial.print(',');
    Serial.print(myArray[0]);Serial.print(myArray[1]);Serial.print(myArray[2]);
    //Serial.println(bmp.pressureToAltitude(1013.25, pressure));
    Serial.print(',');
    Serial.print(x); Serial.print("m/s");
    Serial.print(',');
    Serial.print(ugm3); Serial.println("pm1");
  } 
  
  else {
    Serial.println("Error opening data file!");
  }

  delay(10000);  // 10초 기다림
}
